unit UFRegionales;

interface
uses
  SysUtils, Variants, Classes, math, UApoyo;


  procedure FR_BordeX    ( Ma : Mat3d; var Mb : Mat3d);
  procedure FR_BordeY    ( Ma : Mat3d; var Mb : Mat3d);
  procedure FR_BordeXY   ( Ma : Mat3d; var Mb : Mat3d);

  procedure FR_BordeConX ( Ma : Mat3d; var Mb : Mat3d;
                           MC : MatC3x3);

  function  Conv3        ( Ma : Mat3d; MC : MatC3x3;
                          x,y,can : integer): single;

implementation

// Borde X Simple
  procedure FR_BordeX( Ma : Mat3d; var Mb : Mat3d);
  var
    x,y,can : integer;
  begin
    Mat2Mat(Ma,Mb);

    for can := 0 to 2 do if Kanales[can]
      then // aplica el filtro
        for y := _y1 to _y2 - 1 do
          for x := _x1 to _x2 - 2 do
          // ---
            Mb.dat[x][y][can] := Ma.dat[x+1][y][can] -
                                 Ma.dat[x  ][y][can];
          // ---
  end;

// Borde Y Simple
  procedure FR_BordeY( Ma : Mat3d; var Mb : Mat3d);
  var
    x,y,can : integer;
  begin
    Mat2Mat(Ma,Mb);

    for can := 0 to 2 do if Kanales[can]
      then // aplica el filtro
        for y := _y1 to _y2 - 2 do
          for x := _x1 to _x2 - 1 do
          // ---
            Mb.dat[x][y][can] := Ma.dat[x][y+1][can] -
                                 Ma.dat[x][y  ][can];
          // ---
  end;

// Borde X-Y Simple
  procedure FR_BordeXY  ( Ma : Mat3d; var Mb : Mat3d);
  var
    x,y,can : integer;
    dx,dy   : single;
  begin
    Mat2Mat(Ma,Mb);

    for can := 0 to 2 do if Kanales[can]
      then // aplica el filtro
        for y := _y1 to _y2 - 2 do
          for x := _x1 to _x2 - 2 do begin
          // ---
            dx := Ma.dat[x+1][y][can] -
                  Ma.dat[x  ][y][can];
            dy := Ma.dat[x][y+1][can] -
                  Ma.dat[x][y  ][can];
            Mb.dat[x][y][can] := MAX(abs(dx),abs(dy));
          // ---

          end;
  end;

  // Convolucin 3x3
  function  Conv3       ( Ma : Mat3d; MC : MatC3x3;
                          x,y,can : integer):single;
  var
    i,j : integer;
    sum : single;
  begin
    sum := 0;
    for j := -1 to 1 do
      for i := -1 to 1 do
        sum := sum + Ma.dat[x+i][y+j][can]*MC[i][j];

    result := sum;    
  end;

  // Prewitt/X  Convolucin
  procedure FR_BordeConX ( Ma : Mat3d; var Mb : Mat3d;
                           MC : MatC3x3);
var
    x,y,can : integer;
  begin
    Mat2Mat(Ma,Mb);

    for can := 0 to 2 do if Kanales[can]
      then // aplica el filtro
        for y := _y1+1 to _y2 - 2 do
          for x := _x1+1 to _x2 - 2 do
          // ---
            Mb.dat[x][y][can]:= Conv3(Ma,MC, x,y,can)
          // ---
  end;

end.
