unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes,
  Graphics, Controls, Forms, Dialogs, ExtCtrls,
  Menus, ComCtrls, gfx_files,
  ImgList, ToolWin, StdCtrls,
  UApoyo, UFPuntuales, UFRegionales;

const
  MatW : MatC3x3 = ((-1,0,1),(-1,0,1),(-1,0,1));


type
  TForm1 = class(TForm)
    ScrollBox1: TScrollBox;
    Image1: TImage;
    OpenDialog1: TOpenDialog;
    MainMenu1: TMainMenu;
    Archivo1: TMenuItem;
    Abrir1: TMenuItem;
    StatusBar1: TStatusBar;
    Propiedades1: TMenuItem;
    Varios1: TMenuItem;
    FPuntuales1: TMenuItem;
    Negativo1: TMenuItem;
    Salvar1: TMenuItem;
    SaveDialog1: TSaveDialog;
    Negativo2: TMenuItem;
    onosdeGris1: TMenuItem;
    Luminancia1: TMenuItem;
    N1: TMenuItem;
    Logaritmo1: TMenuItem;
    StatusBar2: TStatusBar;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ImageList1: TImageList;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    Gamma1: TMenuItem;
    Histograma1: TMenuItem;
    Panel1: TPanel;
    GroupBox1: TGroupBox;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    Image2: TImage;
    RadioGroup1: TRadioGroup;
    Deshacer1: TMenuItem;
    FRegionales1: TMenuItem;
    BordesX1: TMenuItem;
    BordesY1: TMenuItem;
    BordesXY1: TMenuItem;
    RadioGroup2: TRadioGroup;
    BordeConvolucion: TMenuItem;
    
    procedure Abrir1Click(Sender: TObject);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure Negativo1Click(Sender: TObject);
    procedure Salvar1Click(Sender: TObject);
    procedure Negativo2Click(Sender: TObject);
    procedure onosdeGris1Click(Sender: TObject);
    procedure Logaritmo1Click(Sender: TObject);
    procedure Gamma1Click(Sender: TObject);
    procedure Histograma1Click(Sender: TObject);

    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure Image2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Image2MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure RadioGroup1Click(Sender: TObject);
    procedure Deshacer1Click(Sender: TObject);
    procedure BordesX1Click(Sender: TObject);
    procedure BordesY1Click(Sender: TObject);
    procedure BordesXY1Click(Sender: TObject);

    procedure BordeXClick(Sender: TObject);

  private
    { Private declarations }
    __x1, __y1, __x2, __y2  : integer;
  public
    { Public declarations }
    BMap,BMS  : TBitMap;
    M1,M2     : Mat3d;
    MatU      : array of MatC3x3;

    procedure Mostrar(M : Mat3d);

    procedure leer_Bordes(nom : string);
  end;

var
  Form1: TForm1;

implementation

uses UCap_R, UHisto;

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
var  kk : integer;
begin
  Application.Icon.LoadFromFile('radiation.ico');

  BMap := TBitMap.Create;
  BMS  := TBitMap.Create;

  for kk := 0 to 2 do Kanales[kk] := true;

  BMS.Canvas.Brush.Color := clWhite;
  BMS.TransparentColor   := clWhite;
  BMS.Transparent        := true;

  leer_bordes('mBordes.dat');
end;

// leer matrices de bordes
procedure TForm1.leer_Bordes(nom : string);
var
  id     : TextFile;
  nomF   : String;
  NF,kk,
  n,m,
  i,j    : integer;

  hijo   : TMenuItem;

begin
  AssignFile(id,nom);
  reset(id);

  // leer en nmero de Mscaras
  readln(id,NF);
  SetLength(MatU,NF);

  for kk := 0 to NF - 1 do begin

    hijo := TMenuItem.Create(self);
    readln(id,nomF);
    hijo.Name    := nomF;
    hijo.Caption := nomF;
    hijo.OnClick := BordeXClick;

    BordeConvolucion.Add(hijo);

    readln(id,n,m);
    for j := -1 to 1 do begin
      for i := -1 to 1 do
        read(id, MatU[kk][i][j]);
      readln(id);
    end;

  end;

  closeFile(id);
end;

// Abrir Imagen
procedure TForm1.Abrir1Click(Sender: TObject);
var
  nom : string;
begin
  OpenDialog1.Filter := gfx_files._OpenFilterString;
  if OpenDialog1.Execute then begin
    nom := Opendialog1.FileName;
    gfx_Files.LoadAnyImageToBMP(BMap,nom,false,0,0);

    BM2Mat(BMap,M1);

    _x1 := 0;
    _y1 := 0;

    _x2 := M1.nc;
    _y2 := M1.nr;

    SetMat(M2,0,0,0);
    Image1.Picture.Assign(BMap) ;

    // cambio de tamao
    BMS.Width  := M1.nc;
    BMS.Height := M1.nr;

    BMS.Canvas.Pen.Color   := clWhite;
    BMS.Canvas.Rectangle(0,0,M1.nc+1,M1.nr+1);
    Image2.Picture.Assign(BMS);

  end;
end;

procedure TForm1.Salvar1Click(Sender: TObject);
var
  nom : string;
begin
  SaveDialog1.Filter := gfx_files._SaveFilterString;
  if SaveDialog1.Execute then begin
    nom := SaveDialog1.FileName;
    gfx_files.SaveBMPToAnyFile(BMap,nom,0,0);
  end;

end;

(*                    Interface                  *)

procedure TForm1.Image1MouseMove(Sender: TObject;
  Shift: TShiftState;
  X, Y : Integer);
var
 pix    : integer;
 r,g, b : byte;
begin

  StatusBar1.Panels[0].Text := IntToStr(X);
  StatusBar1.Panels[1].Text := IntToStr(Y);

  pix := Image1.Canvas.Pixels[X,Y];
  r := GetRValue (pix);
  g := GetGValue (pix);
  b := GetBValue (pix);

  StatusBar1.Panels[2].Text := IntToStr(r);
  StatusBar1.Panels[3].Text := IntToStr(g);
  StatusBar1.Panels[4].Text := IntToStr(b);
end;

// MouseDown / Image2
procedure TForm1.Image2MouseDown(Sender: TObject;
  Button: TMouseButton;
  Shift: TShiftState;
  X, Y: Integer);
begin
  if (Button = mbLeft) and (RadioGroup1.ItemIndex=1 ) then begin
    _x1 := X;
    _y1 := Y;
  end;
end;

// MouseUp / Image2
procedure TForm1.Image2MouseUp(Sender: TObject;
  Button: TMouseButton;
  Shift: TShiftState;
  X, Y: Integer);
begin
  if (Button = mbLeft) and (RadioGroup1.ItemIndex=1 ) then begin
    _x2 := X;
    _y2 := Y;


    BMS.Canvas.Pen.Color := clWhite;
    BMS.Canvas.Rectangle(__x1,__y1,__x2,__y2);

    BMS.Canvas.Pen.Color := clYellow;
    BMS.Canvas.Rectangle(_x1,_y1,_x2,_y2);
    __x1 := _x1;
    __y1 := _y1;
    __x2 := _x2;
    __y2 := _y2;

    Image2.Picture.Assign(BMS);
  end;
end;

// Se quita la seleccion
procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
 if RadioGroup1.ItemIndex=0 then begin
   BMS.Canvas.Pen.Color := clWhite;
   BMS.Canvas.Rectangle(__x1,__y1,__x2,__y2);
   Image2.Picture.Assign(BMS);

   _x1 := 0    ; _y1 := 0;
   _x2 := M1.nc; _y2 := M1.nr;

 end;
end;

// seleccion de canales
//    -- Rojo --
procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  Kanales[0] := CheckBox1.Checked;
end;

// -- Verde --
procedure TForm1.CheckBox2Click(Sender: TObject);
begin
  Kanales[1] := CheckBox2.Checked;
end;

// -- Azul --
procedure TForm1.CheckBox3Click(Sender: TObject);
begin
  Kanales[2] := CheckBox3.Checked;
end;

// Deshacer
procedure TForm1.Deshacer1Click(Sender: TObject);
var
  Mt : Mat3d;
begin
  if (M2.nc*M2.nr <> 0) then begin
    Mat2Mat(M2,Mt);  // Mt <- M2
    Mat2Mat(M1,M2);  // M2 <- M1
    Mat2Mat(Mt,M1);  // M1 <- Mt
    SetMat (Mt,0,0,0);
    Mostrar(M2);
  end;
end;

// Mostrar en la interfce la matriz M
procedure TForm1.Mostrar(M : Mat3d);
begin
  Mat2BM (M,BMap);
  Image1.Picture.Assign(BMap);
end;

(*                 Filtros                         *)

// Negativo: z' = Lamb-z
procedure TForm1.Negativo1Click(Sender: TObject);
var
  x,y,pix  : integer;
  r,g,b    : integer;
begin
  for y := 0 to BMap.Height - 1 do
    for x := 0 to BMap.Width - 1 do begin
      pix := BMap.Canvas.Pixels[X,Y];
      r := GetRValue (pix);
      g := GetGValue (pix);
      b := GetBValue (pix);

      r := _Lamb-r;
      g := _Lamb-g;
      b := _Lamb-b;

      pix := RGB(r,g,b);
      BMap.Canvas.Pixels[X,Y] := pix;
    end;
  Image1.Picture.Assign(BMap);
end;

// Filtro de Negativo con Matrices
procedure TForm1.Negativo2Click(Sender: TObject);
begin
  Mat2Mat(M2,M1);

  FP_Negativo(M1,M2);

  Mostrar(M2);
end;

// tonos de Gris
procedure TForm1.onosdeGris1Click(Sender: TObject);
begin
  Mat2Mat(M2,M1);

  FP_Grises(M1,M2);

  Mostrar(M2);
end;

// Logaritmo / Rango Dinmica
procedure TForm1.Logaritmo1Click(Sender: TObject);
begin
  Mat2Mat(M2,M1);

  FP_Logaritmo(M1,M2);

  Mostrar(M2);
end;

// Filtro o Correccion Gamma
procedure TForm1.Gamma1Click(Sender: TObject);
var
  gam  : single;
  verr : integer;
begin
  // para leer el valor de gamma conviene una interface
  // - se construye y luego de invoca
  // - se toma el valor(es) deseado(s) de ella y se usa(n)

  FCapR.ShowModal;
  if (FCapR.ModalResult = mrOK) then begin
    //  Conversion directa
    //  gam := StrToFloat(FCapR.Edit1.Text);

    // validando la entrada
    val(FCapR.Edit1.Text,gam,verr);
    if (verr<>0) then begin
      ShowMessage('Error de entrada, revise ...');
      exit;
    end;

    Mat2Mat(M2,M1);

    FP_Gamma(M1,M2,gam);

    Mostrar(M2);
  end;
end;

(*  ............  Regionales ......................   *)

(*                  Bordes                            *)

// Simples en X
procedure TForm1.BordesX1Click(Sender: TObject);
begin
  Mat2Mat(M2,M1);

  FR_BordeX(M1,M2);

  case RadioGroup2.ItemIndex of
    0 : NormaAbs (M2,M2);
    1 : NormaRep (M2,M2);
  end;

  Mostrar(M2);
end;

// Bordes simples en Y
procedure TForm1.BordesY1Click(Sender: TObject);
begin
  Mat2Mat(M2,M1);

  FR_BordeY(M1,M2);

  case RadioGroup2.ItemIndex of
    0 : NormaAbs (M2,M2);
    1 : NormaRep (M2,M2);
  end;

  Mostrar(M2);
end;

procedure TForm1.BordesXY1Click(Sender: TObject);
begin
  Mat2Mat(M2,M1);

  FR_BordeXY(M1,M2);

  case RadioGroup2.ItemIndex of
    0 : NormaAbs (M2,M2);
    1 : NormaRep (M2,M2);
  end;

  Mostrar(M2);
end;

// Filtro convolucin : Prewitt/X
procedure TForm1.BordeXClick(Sender: TObject);
var
  opc   : integer;
  item  : TMenuItem;

begin
  Mat2Mat(M2,M1);

  // Cual filtro es??
  item := Sender as TMenuItem;
  opc  := BordeConvolucion.IndexOf(item);

  FR_BordeConX(M1,M2,MatU[opc]);

  case RadioGroup2.ItemIndex of
    0 : NormaAbs (M2,M2);
    1 : NormaRep (M2,M2);
  end;

  Mostrar(M2);
end;

(*                   Histograma       *)

procedure TForm1.Histograma1Click(Sender: TObject);
begin
  FormHisto.Show;
end;

end.
